c
c	read in u and v
c	write div/vort/streamfn/vel-pot
c
c	for lola grids
c
c input
c	unit=50 u (grib)
c	unit=51 u (grib index)
c
c output (grib)
c	unit=15
c
	parameter (nx=144,ny=73, nxny=nx*ny)

c	old - used in v1.1
c	parameter (nwave=62,iromb=0)
c	parameter (nwaves=63*64, ngx=192,ngy=94)

c	new - used in v1.2
        parameter (nwave=36,iromb=0)
        parameter (nwaves=37*38, ngx=192,ngy=94)

	parameter (iptv=1)
        parameter (maxv=100000)
	parameter (iscale=2)
 
        logical lbms(maxv), hasbtx, hasbty
        real datax(maxv), datay(maxv)
        integer kpdsx(100),kgdsx(100),reclx,offsetx, offset1
        integer kpdsy(100),kgdsy(100),recly,offsety

	real u(nxny), v(nxny), vort(nxny), div(nxny)
	real stream(nxny), velpot(nxny)
	integer dscale(255)
	integer levs(17)
	data levs/1000,925,850,700,600,500,400,300,250,200,150,
     1		100,70,50,30,20,10/

	call baopen(50,'fort.50',iret)
	if (iret.ne.0) then
	    write(*,*) 'error opening unit 50'
	    call exit(8)
	endif
	call baopen(51,'fort.51',iret)
	if (iret.ne.0) then
	    write(*,*) 'error opening unit 51'
	    call exit(8)
	endif
	call baopen(52,'fort.52',iret)
	if (iret.ne.0) then
	    write(*,*) 'error opening unit 52'
	    call exit(8)
	endif
	call baopen(53,'fort.53',iret)
	if (iret.ne.0) then
	    write(*,*) 'error opening unit 53'
	    call exit(8)
	endif

	inumx = 0
	inumy = 0

	call idsdef(iptv,dscale)

	do ilev = 1, 17

	    do i = 1, 100
	        kpdsx(i) = -1
	        kpdsy(i) = -1
	    enddo

            call atok5('UGRD',id)
	    kpdsx(5) = id
            call atok5('VGRD',id)
	    kpdsy(5) = id

c	    level
	    kpdsx(6) = 100
	    kpdsy(6) = 100
	    kpdsx(7) = levs(ilev)
	    kpdsy(7) = levs(ilev)

c	    read U
            call pdscan(51,kpdsx,inumx,offsetx,reclx)
            if (reclx.eq.0) then
	        write(*,*) 'missing UGRD'
                call exit(8)
            endif
            call rdgb(50,reclx,offsetx,kpdsx,kgdsx,ndatax,lbms,datax)
 
c	    read V
            call pdscan(51,kpdsy,inumy,offsety,recly)
            if (recly.eq.0) then
                write(*,*) 'missing VGRD'
                call exit(8)
            endif
            call rdgb(50,recly,offsety,kpdsy,kgdsy,ndatay,lbms,datay)

c           check kpds for identical except for U vs V
            do i = 1, 21
                if (i.ne.5.and.kpdsx(i).ne.kpdsy(i)) then
                    write(*,*) 'stream mismatch in kpds ',i
		    write(*,*) 'UGRD:'
		    write(*,*) (kpdsx(j),j=1,21)
		    write(*,*) 'VGRD:'
		    write(*,*) (kpdsy(j),j=1,21)
                    call exit(8)
                endif
            enddo

	if (kpdsx(16).eq.118.) then
	    write(*,*) 'picked up variance!!! not mean'
	    call exit(8)
	endif
 
        call getbit(kpdsx, kgdsx, hasbtx)
        if (hasbtx) then
            write(*,*) 'expecting no bitmap - but has bitmap'
            call exit(8)
	endif
 
        call getbit(kpdsy, kgdsy, hasbty)
        if (hasbty) then
            write(*,*) 'expecting no bitmap - but has bitmap'
            call exit(8)
	endif

	if (kgdsx(2).ne.nx .or. kgdsx(3).ne.ny) then
	    write(*,*) 'wrong dim of U/V grids'
	    call exit(8)
	endif
 
	do i = 1, nxny
	    u(i) = datax(i)
	    v(i) = datay(i)
	enddo

	call uv2all(u,v, .true., vort, .true., stream,
     1		.true., div, .true., velpot, nx, ny, 1, nwave)

        call atok5('RELV',id)
	kpdsx(5) = id
	if (id.eq.-1) then
	    write(*,*) 'RELV undef'
	    call exit(8)
	endif
	kpdsx(22)=dscale(id)+iscale
        call ezgbwk(vort,lbms,kpdsx,kgdsx,15)

        call atok5('RELD',id)
	kpdsx(5) = id
	if (id.eq.-1) then
	    write(*,*) 'RELD undef'
	    call exit(8)
	endif
	kpdsx(22)=dscale(id)+iscale
        call ezgbwk(div,lbms,kpdsx,kgdsx,15)

        call atok5('STRM',id)
	kpdsx(5) = id
	if (id.eq.-1) then
	    write(*,*) 'STRM undef'
	    call exit(8)
	endif
	kpdsx(22)=dscale(id)+iscale
        call ezgbwk(stream,lbms,kpdsx,kgdsx,15)

        call atok5('VPOT',id)
	kpdsx(5) = id
	if (id.eq.-1) then
	    write(*,*) 'VPOT undef'
	    call exit(8)
	endif
	kpdsx(22)=dscale(id)+iscale
        call ezgbwk(velpot,lbms,kpdsx,kgdsx,15)
 
	enddo
 
	write(*,*) 'end of job'
	call exit(0)
	stop
6000	continue
	write(*,*) 'bad write'
	call exit(8)
	stop
	end
